# Описание процесса установки ОС на eMMC одноплатного компьютера Orange PI 5 Plus

Дано:

- плата Orange PI 5 Plus
- SD-карта 16 Гб
- модуль eMMC установлен в плату
- SSD накопитель для данных установлен в плату

## Выбор ОС

Для Orange PI 5 Plus доступно несколько вариантов ОС:

- от производителя платы - [Shenzhen Xunlong Software](http://www.orangepi.org/html/hardWare/computerAndMicrocontrollers/service-and-support/Orange-Pi-5-plus-32GB.html)
- от сообщества [Armbian](https://www.armbian.com/orange-pi-5-plus/)
- от энтузиаста [Joshua-Riek/ubuntu-rockchip](https://github.com/Joshua-Riek/ubuntu-rockchip)

Образы от Joshua-Riek поддерживают аппаратное 3D ускорение и используют стандартные репозитории Ubuntu. В примере будет использован образ на основе Ubuntu 24.04 Desktop с рабочим столом Gnome с Wayland.

## Запись образа на SD-карту

- Скачать образ - <https://joshua-riek.github.io/ubuntu-rockchip-download/boards/orangepi-5-plus.html>
- Записать образ на SD-карту с помощью утилит типа [balenaEtcher](https://etcher.balena.io/)
- Расширить раздел на SD-карте и скопировать туда файл образа в формате `.img`. Таким образом получится на SD-карту образ будет записан дважды: сначала с помощью утилиты [balenaEtcher](https://etcher.balena.io/), а затем на карту скопирован файл образа. Это необходимо для копирования образа на eMMC
- Установить SD-карту в плату

## Запись образа на eMMC

После включения Orange PI 5 Plus с установленной SD-картой, загрузка будет выполнена с SD-карты.

При первой загрузке происходит предварительная настройка ОС - установка локали, создание пользователи и т.д.

Образ ОС хранится в виде `.img` на SD-карте, его необходимо скопировать на eMMC.

Необходимо определить наименование eMMC в системе, в моём случае это `mmcblk0`

```shell
da2001@opi:~$ lsblk
NAME         MAJ:MIN RM   SIZE RO TYPE MOUNTPOINTS
loop0          7:0    0  69,2M  1 loop /snap/core22/1624
loop1          7:1    0  94,4M  1 loop /snap/lxd/30134
loop2          7:2    0  33,7M  1 loop /snap/snapd/21761
mtdblock0     31:0    0    16M  0 disk 
mmcblk1      179:0    0  14,8G  0 disk 
└─mmcblk1p1  179:1    0  14,8G  0 part /
mmcblk0      179:32   0   233G  0 disk 
mmcblk0boot0 179:64   0     4M  1 disk 
mmcblk0boot1 179:96   0     4M  1 disk 
nvme0n1      259:0    0 953,9G  0 disk 
├─nvme0n1p1  259:1    0   500G  0 part 
├─nvme0n1p2  259:2    0   300G  0 part 
└─nvme0n1p3  259:3    0 153,9G  0 part 
```

Копирование образа - `dd if=ubuntu-24.04-preinstalled-desktop-arm64-orangepi-5-plus.img of=/dev/mmcblk0 bs=1M status=progress`

```shell
da2001@opi:~$ sudo -i
[sudo] password for da2001: 
root@opi:~# ls
snap  ubuntu-24.04-preinstalled-desktop-arm64-orangepi-5-plus.img
root@opi:~# dd if=ubuntu-24.04-preinstalled-desktop-arm64-orangepi-5-plus.img of=/dev/mmcblk0 bs=1M status=progress
7388266496 bytes (7,4 GB, 6,9 GiB) copied, 108 s, 68,4 MB/s
7097+0 records in
7097+0 records out
7441743872 bytes (7,4 GB, 6,9 GiB) copied, 110,743 s, 67,2 MB/s
root@opi:~# sync
root@opi:~# 
```

## Завершение

После копирования образа на eMMC, компьютер необходимо выключить и извлечь SD-карту.

Следующая загрузка будет уже с eMMC.

***

<https://habr.com/ru/companies/timeweb/articles/861844/>
